{-# OPTIONS -XEmptyDataDecls #-}
module NET.System.DateTime ( module NET.System.DateTime ) where

import NET
import NET.System.DateTime.Type as NET.System.DateTime
import qualified NET.System.TimeSpan
import qualified Data.Int
import qualified NET.System.Object
import qualified NET.System.DateTimeKind
import qualified NET.System.DayOfWeek
import qualified NET.System.IFormatProvider
import qualified NET.System.Globalization.DateTimeStyles
import qualified NET.System.Array
import qualified NET.System.TypeCode
import qualified NET.System.ValueType

add :: NET.System.TimeSpan.TimeSpan a0 -> DateTime obj -> IO (NET.System.DateTime.DateTime a1)
add arg0 = invoke "Add" (arg0)

addDays :: Double -> DateTime obj -> IO (NET.System.DateTime.DateTime a1)
addDays arg0 = invoke "AddDays" (arg0)

addHours :: Double -> DateTime obj -> IO (NET.System.DateTime.DateTime a1)
addHours arg0 = invoke "AddHours" (arg0)

addMilliseconds :: Double -> DateTime obj -> IO (NET.System.DateTime.DateTime a1)
addMilliseconds arg0 = invoke "AddMilliseconds" (arg0)

addMinutes :: Double -> DateTime obj -> IO (NET.System.DateTime.DateTime a1)
addMinutes arg0 = invoke "AddMinutes" (arg0)

addMonths :: Data.Int.Int32 -> DateTime obj -> IO (NET.System.DateTime.DateTime a1)
addMonths arg0 = invoke "AddMonths" (arg0)

addSeconds :: Double -> DateTime obj -> IO (NET.System.DateTime.DateTime a1)
addSeconds arg0 = invoke "AddSeconds" (arg0)

addTicks :: Data.Int.Int64 -> DateTime obj -> IO (NET.System.DateTime.DateTime a1)
addTicks arg0 = invoke "AddTicks" (arg0)

addYears :: Data.Int.Int32 -> DateTime obj -> IO (NET.System.DateTime.DateTime a1)
addYears arg0 = invoke "AddYears" (arg0)

compare :: NET.System.DateTime.DateTime a0 -> NET.System.DateTime.DateTime a1 -> IO (Data.Int.Int32)
compare arg0 arg1 = invokeStatic "System.DateTime" "Compare" (arg0, arg1)

compareTo :: NET.System.Object.Object a0 -> DateTime obj -> IO (Data.Int.Int32)
compareTo arg0 = invoke "CompareTo" (arg0)

compareTo_1 :: NET.System.DateTime.DateTime a0 -> DateTime obj -> IO (Data.Int.Int32)
compareTo_1 arg0 = invoke "CompareTo" (arg0)

daysInMonth :: Data.Int.Int32 -> Data.Int.Int32 -> IO (Data.Int.Int32)
daysInMonth arg0 arg1 = invokeStatic "System.DateTime" "DaysInMonth" (arg0, arg1)

equals :: NET.System.Object.Object a0 -> DateTime obj -> IO (Bool)
equals arg0 = invoke "Equals" (arg0)

equals_1 :: NET.System.DateTime.DateTime a0 -> DateTime obj -> IO (Bool)
equals_1 arg0 = invoke "Equals" (arg0)

equals_2 :: NET.System.DateTime.DateTime a0 -> NET.System.DateTime.DateTime a1 -> IO (Bool)
equals_2 arg0 arg1 = invokeStatic "System.DateTime" "Equals" (arg0, arg1)

fromBinary :: Data.Int.Int64 -> IO (NET.System.DateTime.DateTime a1)
fromBinary arg0 = invokeStatic "System.DateTime" "FromBinary" (arg0)

fromFileTime :: Data.Int.Int64 -> IO (NET.System.DateTime.DateTime a1)
fromFileTime arg0 = invokeStatic "System.DateTime" "FromFileTime" (arg0)

fromFileTimeUtc :: Data.Int.Int64 -> IO (NET.System.DateTime.DateTime a1)
fromFileTimeUtc arg0 = invokeStatic "System.DateTime" "FromFileTimeUtc" (arg0)

fromOADate :: Double -> IO (NET.System.DateTime.DateTime a1)
fromOADate arg0 = invokeStatic "System.DateTime" "FromOADate" (arg0)

isDaylightSavingTime :: DateTime obj -> IO (Bool)
isDaylightSavingTime = invoke "IsDaylightSavingTime" () 

specifyKind :: NET.System.DateTime.DateTime a0 -> NET.System.DateTimeKind.DateTimeKind a1 -> IO (NET.System.DateTime.DateTime a2)
specifyKind arg0 arg1 = invokeStatic "System.DateTime" "SpecifyKind" (arg0, arg1)

toBinary :: DateTime obj -> IO (Data.Int.Int64)
toBinary = invoke "ToBinary" () 

get_Date :: DateTime obj -> IO (NET.System.DateTime.DateTime a0)
get_Date = invoke "get_Date" () 

get_Day :: DateTime obj -> IO (Data.Int.Int32)
get_Day = invoke "get_Day" () 

get_DayOfWeek :: DateTime obj -> IO (NET.System.DayOfWeek.DayOfWeek a0)
get_DayOfWeek = invoke "get_DayOfWeek" () 

get_DayOfYear :: DateTime obj -> IO (Data.Int.Int32)
get_DayOfYear = invoke "get_DayOfYear" () 

getHashCode :: DateTime obj -> IO (Data.Int.Int32)
getHashCode = invoke "GetHashCode" () 

get_Hour :: DateTime obj -> IO (Data.Int.Int32)
get_Hour = invoke "get_Hour" () 

get_Kind :: DateTime obj -> IO (NET.System.DateTimeKind.DateTimeKind a0)
get_Kind = invoke "get_Kind" () 

get_Millisecond :: DateTime obj -> IO (Data.Int.Int32)
get_Millisecond = invoke "get_Millisecond" () 

get_Minute :: DateTime obj -> IO (Data.Int.Int32)
get_Minute = invoke "get_Minute" () 

get_Month :: DateTime obj -> IO (Data.Int.Int32)
get_Month = invoke "get_Month" () 

get_Now :: IO (NET.System.DateTime.DateTime a0)
get_Now = invokeStatic "System.DateTime" "get_Now" () 

get_UtcNow :: IO (NET.System.DateTime.DateTime a0)
get_UtcNow = invokeStatic "System.DateTime" "get_UtcNow" () 

get_Second :: DateTime obj -> IO (Data.Int.Int32)
get_Second = invoke "get_Second" () 

get_Ticks :: DateTime obj -> IO (Data.Int.Int64)
get_Ticks = invoke "get_Ticks" () 

get_TimeOfDay :: DateTime obj -> IO (NET.System.TimeSpan.TimeSpan a0)
get_TimeOfDay = invoke "get_TimeOfDay" () 

get_Today :: IO (NET.System.DateTime.DateTime a0)
get_Today = invokeStatic "System.DateTime" "get_Today" () 

get_Year :: DateTime obj -> IO (Data.Int.Int32)
get_Year = invoke "get_Year" () 

isLeapYear :: Data.Int.Int32 -> IO (Bool)
isLeapYear arg0 = invokeStatic "System.DateTime" "IsLeapYear" (arg0)

parse :: String -> IO (NET.System.DateTime.DateTime a1)
parse arg0 = invokeStatic "System.DateTime" "Parse" (arg0)

parse_1 :: (NET.System.IFormatProvider.IFormatProvider a1) => String -> NET.System.Object.Object a1 -> IO (NET.System.DateTime.DateTime a2)
parse_1 arg0 arg1 = invokeStatic "System.DateTime" "Parse" (arg0, arg1)

parse_2 :: (NET.System.IFormatProvider.IFormatProvider a1) => String -> NET.System.Object.Object a1 -> NET.System.Globalization.DateTimeStyles.DateTimeStyles a2 -> IO (NET.System.DateTime.DateTime a3)
parse_2 arg0 arg1 arg2 = invokeStatic "System.DateTime" "Parse" (arg0, arg1, arg2)

parseExact :: (NET.System.IFormatProvider.IFormatProvider a2) => String -> String -> NET.System.Object.Object a2 -> IO (NET.System.DateTime.DateTime a3)
parseExact arg0 arg1 arg2 = invokeStatic "System.DateTime" "ParseExact" (arg0, arg1, arg2)

parseExact_1 :: (NET.System.IFormatProvider.IFormatProvider a2) => String -> String -> NET.System.Object.Object a2 -> NET.System.Globalization.DateTimeStyles.DateTimeStyles a3 -> IO (NET.System.DateTime.DateTime a4)
parseExact_1 arg0 arg1 arg2 arg3 = invokeStatic "System.DateTime" "ParseExact" (arg0, arg1, arg2, arg3)

parseExact_2 :: (NET.System.IFormatProvider.IFormatProvider a2) => String -> NET.System.Array.Array (String) -> NET.System.Object.Object a2 -> NET.System.Globalization.DateTimeStyles.DateTimeStyles a3 -> IO (NET.System.DateTime.DateTime a4)
parseExact_2 arg0 arg1 arg2 arg3 = invokeStatic "System.DateTime" "ParseExact" (arg0, arg1, arg2, arg3)

subtract :: NET.System.DateTime.DateTime a0 -> DateTime obj -> IO (NET.System.TimeSpan.TimeSpan a1)
subtract arg0 = invoke "Subtract" (arg0)

subtract_1 :: NET.System.TimeSpan.TimeSpan a0 -> DateTime obj -> IO (NET.System.DateTime.DateTime a1)
subtract_1 arg0 = invoke "Subtract" (arg0)

toOADate :: DateTime obj -> IO (Double)
toOADate = invoke "ToOADate" () 

toFileTime :: DateTime obj -> IO (Data.Int.Int64)
toFileTime = invoke "ToFileTime" () 

toFileTimeUtc :: DateTime obj -> IO (Data.Int.Int64)
toFileTimeUtc = invoke "ToFileTimeUtc" () 

toLocalTime :: DateTime obj -> IO (NET.System.DateTime.DateTime a0)
toLocalTime = invoke "ToLocalTime" () 

toLongDateString :: DateTime obj -> IO (String)
toLongDateString = invoke "ToLongDateString" () 

toLongTimeString :: DateTime obj -> IO (String)
toLongTimeString = invoke "ToLongTimeString" () 

toShortDateString :: DateTime obj -> IO (String)
toShortDateString = invoke "ToShortDateString" () 

toShortTimeString :: DateTime obj -> IO (String)
toShortTimeString = invoke "ToShortTimeString" () 

toString :: DateTime obj -> IO (String)
toString = invoke "ToString" () 

toString_1 :: String -> DateTime obj -> IO (String)
toString_1 arg0 = invoke "ToString" (arg0)

toString_2 :: (NET.System.IFormatProvider.IFormatProvider a0) => NET.System.Object.Object a0 -> DateTime obj -> IO (String)
toString_2 arg0 = invoke "ToString" (arg0)

toString_3 :: (NET.System.IFormatProvider.IFormatProvider a1) => String -> NET.System.Object.Object a1 -> DateTime obj -> IO (String)
toString_3 arg0 arg1 = invoke "ToString" (arg0, arg1)

toUniversalTime :: DateTime obj -> IO (NET.System.DateTime.DateTime a0)
toUniversalTime = invoke "ToUniversalTime" () 

tryParse :: String -> NET.System.DateTime.DateTime a1 -> IO (Bool)
tryParse arg0 arg1 = invokeStatic "System.DateTime" "TryParse" (arg0, arg1)

tryParse_1 :: (NET.System.IFormatProvider.IFormatProvider a1) => String -> NET.System.Object.Object a1 -> NET.System.Globalization.DateTimeStyles.DateTimeStyles a2 -> NET.System.DateTime.DateTime a3 -> IO (Bool)
tryParse_1 arg0 arg1 arg2 arg3 = invokeStatic "System.DateTime" "TryParse" (arg0, arg1, arg2, arg3)

tryParseExact :: (NET.System.IFormatProvider.IFormatProvider a2) => String -> String -> NET.System.Object.Object a2 -> NET.System.Globalization.DateTimeStyles.DateTimeStyles a3 -> NET.System.DateTime.DateTime a4 -> IO (Bool)
tryParseExact arg0 arg1 arg2 arg3 arg4 = invokeStatic "System.DateTime" "TryParseExact" (arg0, arg1, arg2, arg3, arg4)

tryParseExact_1 :: (NET.System.IFormatProvider.IFormatProvider a2) => String -> NET.System.Array.Array (String) -> NET.System.Object.Object a2 -> NET.System.Globalization.DateTimeStyles.DateTimeStyles a3 -> NET.System.DateTime.DateTime a4 -> IO (Bool)
tryParseExact_1 arg0 arg1 arg2 arg3 arg4 = invokeStatic "System.DateTime" "TryParseExact" (arg0, arg1, arg2, arg3, arg4)

op_Addition :: NET.System.DateTime.DateTime a0 -> NET.System.TimeSpan.TimeSpan a1 -> IO (NET.System.DateTime.DateTime a2)
op_Addition arg0 arg1 = invokeStatic "System.DateTime" "op_Addition" (arg0, arg1)

op_Subtraction :: NET.System.DateTime.DateTime a0 -> NET.System.TimeSpan.TimeSpan a1 -> IO (NET.System.DateTime.DateTime a2)
op_Subtraction arg0 arg1 = invokeStatic "System.DateTime" "op_Subtraction" (arg0, arg1)

op_Subtraction_1 :: NET.System.DateTime.DateTime a0 -> NET.System.DateTime.DateTime a1 -> IO (NET.System.TimeSpan.TimeSpan a2)
op_Subtraction_1 arg0 arg1 = invokeStatic "System.DateTime" "op_Subtraction" (arg0, arg1)

op_Equality :: NET.System.DateTime.DateTime a0 -> NET.System.DateTime.DateTime a1 -> IO (Bool)
op_Equality arg0 arg1 = invokeStatic "System.DateTime" "op_Equality" (arg0, arg1)

op_Inequality :: NET.System.DateTime.DateTime a0 -> NET.System.DateTime.DateTime a1 -> IO (Bool)
op_Inequality arg0 arg1 = invokeStatic "System.DateTime" "op_Inequality" (arg0, arg1)

op_LessThan :: NET.System.DateTime.DateTime a0 -> NET.System.DateTime.DateTime a1 -> IO (Bool)
op_LessThan arg0 arg1 = invokeStatic "System.DateTime" "op_LessThan" (arg0, arg1)

op_LessThanOrEqual :: NET.System.DateTime.DateTime a0 -> NET.System.DateTime.DateTime a1 -> IO (Bool)
op_LessThanOrEqual arg0 arg1 = invokeStatic "System.DateTime" "op_LessThanOrEqual" (arg0, arg1)

op_GreaterThan :: NET.System.DateTime.DateTime a0 -> NET.System.DateTime.DateTime a1 -> IO (Bool)
op_GreaterThan arg0 arg1 = invokeStatic "System.DateTime" "op_GreaterThan" (arg0, arg1)

op_GreaterThanOrEqual :: NET.System.DateTime.DateTime a0 -> NET.System.DateTime.DateTime a1 -> IO (Bool)
op_GreaterThanOrEqual arg0 arg1 = invokeStatic "System.DateTime" "op_GreaterThanOrEqual" (arg0, arg1)

getDateTimeFormats :: DateTime obj -> IO (NET.System.Array.Array (String))
getDateTimeFormats = invoke "GetDateTimeFormats" () 

getDateTimeFormats_1 :: (NET.System.IFormatProvider.IFormatProvider a0) => NET.System.Object.Object a0 -> DateTime obj -> IO (NET.System.Array.Array (String))
getDateTimeFormats_1 arg0 = invoke "GetDateTimeFormats" (arg0)

getDateTimeFormats_2 :: Char -> DateTime obj -> IO (NET.System.Array.Array (String))
getDateTimeFormats_2 arg0 = invoke "GetDateTimeFormats" (arg0)

getDateTimeFormats_3 :: (NET.System.IFormatProvider.IFormatProvider a1) => Char -> NET.System.Object.Object a1 -> DateTime obj -> IO (NET.System.Array.Array (String))
getDateTimeFormats_3 arg0 arg1 = invoke "GetDateTimeFormats" (arg0, arg1)

getTypeCode :: DateTime obj -> IO (NET.System.TypeCode.TypeCode a0)
getTypeCode = invoke "GetTypeCode" () 

get_MinValue :: IO (NET.System.DateTime.DateTime a0)
get_MinValue = getFieldStatic "System.DateTime" "MinValue" ()
get_MaxValue :: IO (NET.System.DateTime.DateTime a0)
get_MaxValue = getFieldStatic "System.DateTime" "MaxValue" ()

