{-# OPTIONS -XEmptyDataDecls #-}
module NET.System.Delegate ( module NET.System.Delegate ) where

import NET
import NET.System.Delegate.Type as NET.System.Delegate
{-
import qualified NET.System.Array
import qualified NET.System.Object
import qualified NET.System.Reflection.MethodInfo
import qualified NET.System.Type
import qualified NET.System.Runtime.Serialization.SerializationInfo
import qualified NET.System.Runtime.Serialization.StreamingContext

dynamicInvoke :: NET.System.Array.Array (NET.System.Object.Object a0) -> Delegate obj -> IO (NET.System.Object.Object a1)
dynamicInvoke arg0 = invoke "DynamicInvoke" (arg0)

equals :: NET.System.Object.Object a0 -> Delegate obj -> IO (Bool)
equals arg0 = invoke "Equals" (arg0)

getHashCode :: Delegate obj -> IO (Int)
getHashCode = invoke "GetHashCode" () 

combine :: NET.System.Delegate.Delegate a0 -> NET.System.Delegate.Delegate a1 -> IO (NET.System.Delegate.Delegate a2)
combine arg0 arg1 = invokeStatic "System.Delegate" "Combine" (arg0, arg1)

combine_1 :: NET.System.Array.Array (NET.System.Delegate.Delegate a0) -> IO (NET.System.Delegate.Delegate a1)
combine_1 arg0 = invokeStatic "System.Delegate" "Combine" (arg0)

getInvocationList :: Delegate obj -> IO (NET.System.Array.Array (NET.System.Delegate.Delegate a0))
getInvocationList = invoke "GetInvocationList" () 

get_Method :: Delegate obj -> IO (NET.System.Reflection.MethodInfo.MethodInfo a0)
get_Method = invoke "get_Method" () 

get_Target :: Delegate obj -> IO (NET.System.Object.Object a0)
get_Target = invoke "get_Target" () 

remove :: NET.System.Delegate.Delegate a0 -> NET.System.Delegate.Delegate a1 -> IO (NET.System.Delegate.Delegate a2)
remove arg0 arg1 = invokeStatic "System.Delegate" "Remove" (arg0, arg1)

removeAll :: NET.System.Delegate.Delegate a0 -> NET.System.Delegate.Delegate a1 -> IO (NET.System.Delegate.Delegate a2)
removeAll arg0 arg1 = invokeStatic "System.Delegate" "RemoveAll" (arg0, arg1)

clone :: Delegate obj -> IO (NET.System.Object.Object a0)
clone = invoke "Clone" () 

createDelegate :: NET.System.Type.Type a0 -> NET.System.Object.Object a1 -> String -> IO (NET.System.Delegate.Delegate a3)
createDelegate arg0 arg1 arg2 = invokeStatic "System.Delegate" "CreateDelegate" (arg0, arg1, arg2)

createDelegate_1 :: NET.System.Type.Type a0 -> NET.System.Object.Object a1 -> String -> Bool -> IO (NET.System.Delegate.Delegate a4)
createDelegate_1 arg0 arg1 arg2 arg3 = invokeStatic "System.Delegate" "CreateDelegate" (arg0, arg1, arg2, arg3)

createDelegate_2 :: NET.System.Type.Type a0 -> NET.System.Object.Object a1 -> String -> Bool -> Bool -> IO (NET.System.Delegate.Delegate a5)
createDelegate_2 arg0 arg1 arg2 arg3 arg4 = invokeStatic "System.Delegate" "CreateDelegate" (arg0, arg1, arg2, arg3, arg4)

createDelegate_3 :: NET.System.Type.Type a0 -> NET.System.Type.Type a1 -> String -> IO (NET.System.Delegate.Delegate a3)
createDelegate_3 arg0 arg1 arg2 = invokeStatic "System.Delegate" "CreateDelegate" (arg0, arg1, arg2)

createDelegate_4 :: NET.System.Type.Type a0 -> NET.System.Type.Type a1 -> String -> Bool -> IO (NET.System.Delegate.Delegate a4)
createDelegate_4 arg0 arg1 arg2 arg3 = invokeStatic "System.Delegate" "CreateDelegate" (arg0, arg1, arg2, arg3)

createDelegate_5 :: NET.System.Type.Type a0 -> NET.System.Type.Type a1 -> String -> Bool -> Bool -> IO (NET.System.Delegate.Delegate a5)
createDelegate_5 arg0 arg1 arg2 arg3 arg4 = invokeStatic "System.Delegate" "CreateDelegate" (arg0, arg1, arg2, arg3, arg4)

createDelegate_6 :: NET.System.Type.Type a0 -> NET.System.Reflection.MethodInfo.MethodInfo a1 -> IO (NET.System.Delegate.Delegate a2)
createDelegate_6 arg0 arg1 = invokeStatic "System.Delegate" "CreateDelegate" (arg0, arg1)

createDelegate_7 :: NET.System.Type.Type a0 -> NET.System.Reflection.MethodInfo.MethodInfo a1 -> Bool -> IO (NET.System.Delegate.Delegate a3)
createDelegate_7 arg0 arg1 arg2 = invokeStatic "System.Delegate" "CreateDelegate" (arg0, arg1, arg2)

createDelegate_8 :: NET.System.Type.Type a0 -> NET.System.Object.Object a1 -> NET.System.Reflection.MethodInfo.MethodInfo a2 -> IO (NET.System.Delegate.Delegate a3)
createDelegate_8 arg0 arg1 arg2 = invokeStatic "System.Delegate" "CreateDelegate" (arg0, arg1, arg2)

createDelegate_9 :: NET.System.Type.Type a0 -> NET.System.Object.Object a1 -> NET.System.Reflection.MethodInfo.MethodInfo a2 -> Bool -> IO (NET.System.Delegate.Delegate a4)
createDelegate_9 arg0 arg1 arg2 arg3 = invokeStatic "System.Delegate" "CreateDelegate" (arg0, arg1, arg2, arg3)

op_Equality :: NET.System.Delegate.Delegate a0 -> NET.System.Delegate.Delegate a1 -> IO (Bool)
op_Equality arg0 arg1 = invokeStatic "System.Delegate" "op_Equality" (arg0, arg1)

op_Inequality :: NET.System.Delegate.Delegate a0 -> NET.System.Delegate.Delegate a1 -> IO (Bool)
op_Inequality arg0 arg1 = invokeStatic "System.Delegate" "op_Inequality" (arg0, arg1)

getObjectData :: NET.System.Runtime.Serialization.SerializationInfo.SerializationInfo a0 -> NET.System.Runtime.Serialization.StreamingContext.StreamingContext a1 -> Delegate obj -> IO (())
getObjectData arg0 arg1 = invoke "GetObjectData" (arg0, arg1)


-}
