{-# OPTIONS -XEmptyDataDecls #-}
module NET.System.Globalization.Calendar where

import NET
import qualified NET.System.DateTime
import qualified NET.System.Globalization.CalendarAlgorithmType
import qualified NET.System.Object
import qualified NET.System.DayOfWeek
import qualified NET.System.Array
import qualified NET.System.Globalization.CalendarWeekRule

data Calendar_ a
type Calendar a = NET.System.Object.Object (Calendar_ a)

get_MinSupportedDateTime :: Calendar obj -> IO (NET.System.DateTime.DateTime a0)
get_MinSupportedDateTime = invoke "get_MinSupportedDateTime" () 

get_MaxSupportedDateTime :: Calendar obj -> IO (NET.System.DateTime.DateTime a0)
get_MaxSupportedDateTime = invoke "get_MaxSupportedDateTime" () 

get_AlgorithmType :: Calendar obj -> IO (NET.System.Globalization.CalendarAlgorithmType.CalendarAlgorithmType a0)
get_AlgorithmType = invoke "get_AlgorithmType" () 

get_IsReadOnly :: Calendar obj -> IO (Bool)
get_IsReadOnly = invoke "get_IsReadOnly" () 

clone :: Calendar obj -> IO (NET.System.Object.Object a0)
clone = invoke "Clone" () 

readOnly :: NET.System.Globalization.Calendar.Calendar a0 -> IO (NET.System.Globalization.Calendar.Calendar a1)
readOnly arg0 = invokeStatic "System.Globalization.Calendar" "ReadOnly" (arg0)

addMilliseconds :: NET.System.DateTime.DateTime a0 -> Double -> Calendar obj -> IO (NET.System.DateTime.DateTime a2)
addMilliseconds arg0 arg1 = invoke "AddMilliseconds" (arg0, arg1)

addDays :: NET.System.DateTime.DateTime a0 -> Int -> Calendar obj -> IO (NET.System.DateTime.DateTime a2)
addDays arg0 arg1 = invoke "AddDays" (arg0, arg1)

addHours :: NET.System.DateTime.DateTime a0 -> Int -> Calendar obj -> IO (NET.System.DateTime.DateTime a2)
addHours arg0 arg1 = invoke "AddHours" (arg0, arg1)

addMinutes :: NET.System.DateTime.DateTime a0 -> Int -> Calendar obj -> IO (NET.System.DateTime.DateTime a2)
addMinutes arg0 arg1 = invoke "AddMinutes" (arg0, arg1)

addMonths :: NET.System.DateTime.DateTime a0 -> Int -> Calendar obj -> IO (NET.System.DateTime.DateTime a2)
addMonths arg0 arg1 = invoke "AddMonths" (arg0, arg1)

addSeconds :: NET.System.DateTime.DateTime a0 -> Int -> Calendar obj -> IO (NET.System.DateTime.DateTime a2)
addSeconds arg0 arg1 = invoke "AddSeconds" (arg0, arg1)

addWeeks :: NET.System.DateTime.DateTime a0 -> Int -> Calendar obj -> IO (NET.System.DateTime.DateTime a2)
addWeeks arg0 arg1 = invoke "AddWeeks" (arg0, arg1)

addYears :: NET.System.DateTime.DateTime a0 -> Int -> Calendar obj -> IO (NET.System.DateTime.DateTime a2)
addYears arg0 arg1 = invoke "AddYears" (arg0, arg1)

getDayOfMonth :: NET.System.DateTime.DateTime a0 -> Calendar obj -> IO (Int)
getDayOfMonth arg0 = invoke "GetDayOfMonth" (arg0)

getDayOfWeek :: NET.System.DateTime.DateTime a0 -> Calendar obj -> IO (NET.System.DayOfWeek.DayOfWeek a1)
getDayOfWeek arg0 = invoke "GetDayOfWeek" (arg0)

getDayOfYear :: NET.System.DateTime.DateTime a0 -> Calendar obj -> IO (Int)
getDayOfYear arg0 = invoke "GetDayOfYear" (arg0)

getDaysInMonth :: Int -> Int -> Calendar obj -> IO (Int)
getDaysInMonth arg0 arg1 = invoke "GetDaysInMonth" (arg0, arg1)

getDaysInMonth_1 :: Int -> Int -> Int -> Calendar obj -> IO (Int)
getDaysInMonth_1 arg0 arg1 arg2 = invoke "GetDaysInMonth" (arg0, arg1, arg2)

getDaysInYear :: Int -> Calendar obj -> IO (Int)
getDaysInYear arg0 = invoke "GetDaysInYear" (arg0)

getDaysInYear_1 :: Int -> Int -> Calendar obj -> IO (Int)
getDaysInYear_1 arg0 arg1 = invoke "GetDaysInYear" (arg0, arg1)

getEra :: NET.System.DateTime.DateTime a0 -> Calendar obj -> IO (Int)
getEra arg0 = invoke "GetEra" (arg0)

get_Eras :: Calendar obj -> IO (NET.System.Array.Array (Int))
get_Eras = invoke "get_Eras" () 

getHour :: NET.System.DateTime.DateTime a0 -> Calendar obj -> IO (Int)
getHour arg0 = invoke "GetHour" (arg0)

getMilliseconds :: NET.System.DateTime.DateTime a0 -> Calendar obj -> IO (Double)
getMilliseconds arg0 = invoke "GetMilliseconds" (arg0)

getMinute :: NET.System.DateTime.DateTime a0 -> Calendar obj -> IO (Int)
getMinute arg0 = invoke "GetMinute" (arg0)

getMonth :: NET.System.DateTime.DateTime a0 -> Calendar obj -> IO (Int)
getMonth arg0 = invoke "GetMonth" (arg0)

getMonthsInYear :: Int -> Calendar obj -> IO (Int)
getMonthsInYear arg0 = invoke "GetMonthsInYear" (arg0)

getMonthsInYear_1 :: Int -> Int -> Calendar obj -> IO (Int)
getMonthsInYear_1 arg0 arg1 = invoke "GetMonthsInYear" (arg0, arg1)

getSecond :: NET.System.DateTime.DateTime a0 -> Calendar obj -> IO (Int)
getSecond arg0 = invoke "GetSecond" (arg0)

getWeekOfYear :: NET.System.DateTime.DateTime a0 -> NET.System.Globalization.CalendarWeekRule.CalendarWeekRule a1 -> NET.System.DayOfWeek.DayOfWeek a2 -> Calendar obj -> IO (Int)
getWeekOfYear arg0 arg1 arg2 = invoke "GetWeekOfYear" (arg0, arg1, arg2)

getYear :: NET.System.DateTime.DateTime a0 -> Calendar obj -> IO (Int)
getYear arg0 = invoke "GetYear" (arg0)

isLeapDay :: Int -> Int -> Int -> Calendar obj -> IO (Bool)
isLeapDay arg0 arg1 arg2 = invoke "IsLeapDay" (arg0, arg1, arg2)

isLeapDay_1 :: Int -> Int -> Int -> Int -> Calendar obj -> IO (Bool)
isLeapDay_1 arg0 arg1 arg2 arg3 = invoke "IsLeapDay" (arg0, arg1, arg2, arg3)

isLeapMonth :: Int -> Int -> Calendar obj -> IO (Bool)
isLeapMonth arg0 arg1 = invoke "IsLeapMonth" (arg0, arg1)

isLeapMonth_1 :: Int -> Int -> Int -> Calendar obj -> IO (Bool)
isLeapMonth_1 arg0 arg1 arg2 = invoke "IsLeapMonth" (arg0, arg1, arg2)

getLeapMonth :: Int -> Calendar obj -> IO (Int)
getLeapMonth arg0 = invoke "GetLeapMonth" (arg0)

getLeapMonth_1 :: Int -> Int -> Calendar obj -> IO (Int)
getLeapMonth_1 arg0 arg1 = invoke "GetLeapMonth" (arg0, arg1)

isLeapYear :: Int -> Calendar obj -> IO (Bool)
isLeapYear arg0 = invoke "IsLeapYear" (arg0)

isLeapYear_1 :: Int -> Int -> Calendar obj -> IO (Bool)
isLeapYear_1 arg0 arg1 = invoke "IsLeapYear" (arg0, arg1)

toDateTime :: Int -> Int -> Int -> Int -> Int -> Int -> Int -> Calendar obj -> IO (NET.System.DateTime.DateTime a7)
toDateTime arg0 arg1 arg2 arg3 arg4 arg5 arg6 = invoke "ToDateTime" (arg0, arg1, arg2, arg3, arg4, arg5, arg6)

toDateTime_1 :: Int -> Int -> Int -> Int -> Int -> Int -> Int -> Int -> Calendar obj -> IO (NET.System.DateTime.DateTime a8)
toDateTime_1 arg0 arg1 arg2 arg3 arg4 arg5 arg6 arg7 = invoke "ToDateTime" (arg0, arg1, arg2, arg3, arg4, arg5, arg6, arg7)

get_TwoDigitYearMax :: Calendar obj -> IO (Int)
get_TwoDigitYearMax = invoke "get_TwoDigitYearMax" () 

set_TwoDigitYearMax :: Int -> Calendar obj -> IO (())
set_TwoDigitYearMax arg0 = invoke "set_TwoDigitYearMax" (arg0)

toFourDigitYear :: Int -> Calendar obj -> IO (Int)
toFourDigitYear arg0 = invoke "ToFourDigitYear" (arg0)

get_CurrentEra :: IO (Int)
get_CurrentEra = getFieldStatic "System.Globalization.Calendar" "CurrentEra" ()
set_CurrentEra :: Int -> IO ()
set_CurrentEra = setFieldStatic "System.Globalization.Calendar" "CurrentEra"

