{-# OPTIONS -XEmptyDataDecls #-}
module NET.System.IConvertible ( module NET.System.IConvertible ) where

import NET
import NET.System.IConvertible.Type as NET.System.IConvertible
import qualified NET.System.TypeCode
import qualified NET.System.IFormatProvider
import qualified Data.Int
import qualified Data.Word
import qualified NET.System.Decimal
import qualified NET.System.DateTime
import qualified NET.System.Type
import qualified NET.System.Object

getTypeCode :: (IConvertible obj) => Object obj -> IO (NET.System.TypeCode.TypeCode a0)
getTypeCode = invoke "GetTypeCode" () 

toBoolean :: (NET.System.IFormatProvider.IFormatProvider a0, IConvertible obj) => NET.System.Object.Object a0 -> Object obj -> IO (Bool)
toBoolean arg0 = invoke "ToBoolean" (arg0)

toChar :: (NET.System.IFormatProvider.IFormatProvider a0, IConvertible obj) => NET.System.Object.Object a0 -> Object obj -> IO (Char)
toChar arg0 = invoke "ToChar" (arg0)

toSByte :: (NET.System.IFormatProvider.IFormatProvider a0, IConvertible obj) => NET.System.Object.Object a0 -> Object obj -> IO (Data.Int.Int8)
toSByte arg0 = invoke "ToSByte" (arg0)

toByte :: (NET.System.IFormatProvider.IFormatProvider a0, IConvertible obj) => NET.System.Object.Object a0 -> Object obj -> IO (Data.Word.Word8)
toByte arg0 = invoke "ToByte" (arg0)

toInt16 :: (NET.System.IFormatProvider.IFormatProvider a0, IConvertible obj) => NET.System.Object.Object a0 -> Object obj -> IO (Data.Int.Int16)
toInt16 arg0 = invoke "ToInt16" (arg0)

toUInt16 :: (NET.System.IFormatProvider.IFormatProvider a0, IConvertible obj) => NET.System.Object.Object a0 -> Object obj -> IO (Data.Word.Word16)
toUInt16 arg0 = invoke "ToUInt16" (arg0)

toInt32 :: (NET.System.IFormatProvider.IFormatProvider a0, IConvertible obj) => NET.System.Object.Object a0 -> Object obj -> IO (Data.Int.Int32)
toInt32 arg0 = invoke "ToInt32" (arg0)

toUInt32 :: (NET.System.IFormatProvider.IFormatProvider a0, IConvertible obj) => NET.System.Object.Object a0 -> Object obj -> IO (Data.Word.Word32)
toUInt32 arg0 = invoke "ToUInt32" (arg0)

toInt64 :: (NET.System.IFormatProvider.IFormatProvider a0, IConvertible obj) => NET.System.Object.Object a0 -> Object obj -> IO (Data.Int.Int64)
toInt64 arg0 = invoke "ToInt64" (arg0)

toUInt64 :: (NET.System.IFormatProvider.IFormatProvider a0, IConvertible obj) => NET.System.Object.Object a0 -> Object obj -> IO (Data.Word.Word64)
toUInt64 arg0 = invoke "ToUInt64" (arg0)

toSingle :: (NET.System.IFormatProvider.IFormatProvider a0, IConvertible obj) => NET.System.Object.Object a0 -> Object obj -> IO (Float)
toSingle arg0 = invoke "ToSingle" (arg0)

toDouble :: (NET.System.IFormatProvider.IFormatProvider a0, IConvertible obj) => NET.System.Object.Object a0 -> Object obj -> IO (Double)
toDouble arg0 = invoke "ToDouble" (arg0)

toDecimal :: (NET.System.IFormatProvider.IFormatProvider a0, IConvertible obj) => NET.System.Object.Object a0 -> Object obj -> IO (NET.System.Decimal.Decimal a1)
toDecimal arg0 = invoke "ToDecimal" (arg0)

toDateTime :: (NET.System.IFormatProvider.IFormatProvider a0, IConvertible obj) => NET.System.Object.Object a0 -> Object obj -> IO (NET.System.DateTime.DateTime a1)
toDateTime arg0 = invoke "ToDateTime" (arg0)

toString :: (NET.System.IFormatProvider.IFormatProvider a0, IConvertible obj) => NET.System.Object.Object a0 -> Object obj -> IO (String)
toString arg0 = invoke "ToString" (arg0)

toType :: (NET.System.IFormatProvider.IFormatProvider a1, IConvertible obj) => NET.System.Type.Type a0 -> NET.System.Object.Object a1 -> Object obj -> IO (NET.System.Object.Object a2)
toType arg0 arg1 = invoke "ToType" (arg0, arg1)


