{-# OPTIONS -XEmptyDataDecls #-}
module NET.System.IO.Stream ( module NET.System.IO.Stream ) where

import NET
import NET.System.IO.Stream.Type as NET.System.IO.Stream
import qualified Data.Int
import qualified NET.System.Array
import qualified Data.Word
import qualified NET.System.AsyncCallback
import qualified NET.System.Object
import qualified NET.System.IAsyncResult
import qualified NET.System.IO.SeekOrigin
import qualified NET.System.MarshalByRefObject

get_CanRead :: Stream obj -> IO (Bool)
get_CanRead = invoke "get_CanRead" () 

get_CanSeek :: Stream obj -> IO (Bool)
get_CanSeek = invoke "get_CanSeek" () 

get_CanTimeout :: Stream obj -> IO (Bool)
get_CanTimeout = invoke "get_CanTimeout" () 

get_CanWrite :: Stream obj -> IO (Bool)
get_CanWrite = invoke "get_CanWrite" () 

get_Length :: Stream obj -> IO (Data.Int.Int64)
get_Length = invoke "get_Length" () 

get_Position :: Stream obj -> IO (Data.Int.Int64)
get_Position = invoke "get_Position" () 

set_Position :: Data.Int.Int64 -> Stream obj -> IO (())
set_Position arg0 = invoke "set_Position" (arg0)

get_ReadTimeout :: Stream obj -> IO (Data.Int.Int32)
get_ReadTimeout = invoke "get_ReadTimeout" () 

set_ReadTimeout :: Data.Int.Int32 -> Stream obj -> IO (())
set_ReadTimeout arg0 = invoke "set_ReadTimeout" (arg0)

get_WriteTimeout :: Stream obj -> IO (Data.Int.Int32)
get_WriteTimeout = invoke "get_WriteTimeout" () 

set_WriteTimeout :: Data.Int.Int32 -> Stream obj -> IO (())
set_WriteTimeout arg0 = invoke "set_WriteTimeout" (arg0)

close :: Stream obj -> IO (())
close = invoke "Close" () 

dispose :: Stream obj -> IO (())
dispose = invoke "Dispose" () 

flush :: Stream obj -> IO (())
flush = invoke "Flush" () 

beginRead :: (NET.System.IAsyncResult.IAsyncResult a5) => NET.System.Array.Array (Data.Word.Word8) -> Data.Int.Int32 -> Data.Int.Int32 -> NET.System.AsyncCallback.AsyncCallback a3 -> NET.System.Object.Object a4 -> Stream obj -> IO (NET.System.Object.Object a5)
beginRead arg0 arg1 arg2 arg3 arg4 = invoke "BeginRead" (arg0, arg1, arg2, arg3, arg4)

endRead :: (NET.System.IAsyncResult.IAsyncResult a0) => NET.System.Object.Object a0 -> Stream obj -> IO (Data.Int.Int32)
endRead arg0 = invoke "EndRead" (arg0)

beginWrite :: (NET.System.IAsyncResult.IAsyncResult a5) => NET.System.Array.Array (Data.Word.Word8) -> Data.Int.Int32 -> Data.Int.Int32 -> NET.System.AsyncCallback.AsyncCallback a3 -> NET.System.Object.Object a4 -> Stream obj -> IO (NET.System.Object.Object a5)
beginWrite arg0 arg1 arg2 arg3 arg4 = invoke "BeginWrite" (arg0, arg1, arg2, arg3, arg4)

endWrite :: (NET.System.IAsyncResult.IAsyncResult a0) => NET.System.Object.Object a0 -> Stream obj -> IO (())
endWrite arg0 = invoke "EndWrite" (arg0)

seek :: Data.Int.Int64 -> NET.System.IO.SeekOrigin.SeekOrigin a1 -> Stream obj -> IO (Data.Int.Int64)
seek arg0 arg1 = invoke "Seek" (arg0, arg1)

setLength :: Data.Int.Int64 -> Stream obj -> IO (())
setLength arg0 = invoke "SetLength" (arg0)

read :: NET.System.Array.Array (Data.Word.Word8) -> Data.Int.Int32 -> Data.Int.Int32 -> Stream obj -> IO (Data.Int.Int32)
read arg0 arg1 arg2 = invoke "Read" (arg0, arg1, arg2)

readByte :: Stream obj -> IO (Data.Int.Int32)
readByte = invoke "ReadByte" () 

write :: NET.System.Array.Array (Data.Word.Word8) -> Data.Int.Int32 -> Data.Int.Int32 -> Stream obj -> IO (())
write arg0 arg1 arg2 = invoke "Write" (arg0, arg1, arg2)

writeByte :: Data.Word.Word8 -> Stream obj -> IO (())
writeByte arg0 = invoke "WriteByte" (arg0)

synchronized :: NET.System.IO.Stream.Stream a0 -> IO (NET.System.IO.Stream.Stream a1)
synchronized arg0 = invokeStatic "System.IO.Stream" "Synchronized" (arg0)

get_Null :: IO (NET.System.IO.Stream.Stream a0)
get_Null = getFieldStatic "System.IO.Stream" "Null" ()

