{-# OPTIONS -XEmptyDataDecls #-}
module NET.System.TimeSpan ( module NET.System.TimeSpan ) where

import qualified NET
import NET.System.TimeSpan.Type as NET.System.TimeSpan
import qualified Data.Int
import qualified NET.System.Object
import qualified NET.System.ValueType.Type as NET.System.ValueType

get_Ticks :: TimeSpan obj -> IO (Data.Int.Int64)
get_Ticks obj = NET.invoke "get_Ticks"  ()  obj

get_Days :: TimeSpan obj -> IO (Data.Int.Int32)
get_Days obj = NET.invoke "get_Days"  ()  obj

get_Hours :: TimeSpan obj -> IO (Data.Int.Int32)
get_Hours obj = NET.invoke "get_Hours"  ()  obj

get_Milliseconds :: TimeSpan obj -> IO (Data.Int.Int32)
get_Milliseconds obj = NET.invoke "get_Milliseconds"  ()  obj

get_Minutes :: TimeSpan obj -> IO (Data.Int.Int32)
get_Minutes obj = NET.invoke "get_Minutes"  ()  obj

get_Seconds :: TimeSpan obj -> IO (Data.Int.Int32)
get_Seconds obj = NET.invoke "get_Seconds"  ()  obj

get_TotalDays :: TimeSpan obj -> IO (Double)
get_TotalDays obj = NET.invoke "get_TotalDays"  ()  obj

get_TotalHours :: TimeSpan obj -> IO (Double)
get_TotalHours obj = NET.invoke "get_TotalHours"  ()  obj

get_TotalMilliseconds :: TimeSpan obj -> IO (Double)
get_TotalMilliseconds obj = NET.invoke "get_TotalMilliseconds"  ()  obj

get_TotalMinutes :: TimeSpan obj -> IO (Double)
get_TotalMinutes obj = NET.invoke "get_TotalMinutes"  ()  obj

get_TotalSeconds :: TimeSpan obj -> IO (Double)
get_TotalSeconds obj = NET.invoke "get_TotalSeconds"  ()  obj

add :: NET.System.TimeSpan.TimeSpan a0 -> TimeSpan obj -> IO (NET.System.TimeSpan.TimeSpan a1)
add arg0 obj = NET.invoke "Add"  (arg0) obj

compare :: NET.System.TimeSpan.TimeSpan a0 -> NET.System.TimeSpan.TimeSpan a1 -> IO (Data.Int.Int32)
compare arg0 arg1 = NET.invokeStatic "System.TimeSpan" "Compare"  (arg0, arg1)

compareTo :: NET.System.Object.Object (objTy0 a0) -> TimeSpan obj -> IO (Data.Int.Int32)
compareTo arg0 obj = NET.invoke "CompareTo"  (arg0) obj

compareTo_1 :: NET.System.TimeSpan.TimeSpan a0 -> TimeSpan obj -> IO (Data.Int.Int32)
compareTo_1 arg0 obj = NET.invoke "CompareTo"  (arg0) obj

fromDays :: Double -> IO (NET.System.TimeSpan.TimeSpan a1)
fromDays arg0 = NET.invokeStatic "System.TimeSpan" "FromDays"  (arg0)

duration :: TimeSpan obj -> IO (NET.System.TimeSpan.TimeSpan a0)
duration obj = NET.invoke "Duration"  ()  obj

equals :: NET.System.Object.Object (objTy0 a0) -> TimeSpan obj -> IO (Bool)
equals arg0 obj = NET.invoke "Equals"  (arg0) obj

equals_1 :: NET.System.TimeSpan.TimeSpan a0 -> TimeSpan obj -> IO (Bool)
equals_1 arg0 obj = NET.invoke "Equals"  (arg0) obj

equals_2 :: NET.System.TimeSpan.TimeSpan a0 -> NET.System.TimeSpan.TimeSpan a1 -> IO (Bool)
equals_2 arg0 arg1 = NET.invokeStatic "System.TimeSpan" "Equals"  (arg0, arg1)

getHashCode :: TimeSpan obj -> IO (Data.Int.Int32)
getHashCode obj = NET.invoke "GetHashCode"  ()  obj

fromHours :: Double -> IO (NET.System.TimeSpan.TimeSpan a1)
fromHours arg0 = NET.invokeStatic "System.TimeSpan" "FromHours"  (arg0)

fromMilliseconds :: Double -> IO (NET.System.TimeSpan.TimeSpan a1)
fromMilliseconds arg0 = NET.invokeStatic "System.TimeSpan" "FromMilliseconds"  (arg0)

fromMinutes :: Double -> IO (NET.System.TimeSpan.TimeSpan a1)
fromMinutes arg0 = NET.invokeStatic "System.TimeSpan" "FromMinutes"  (arg0)

negate :: TimeSpan obj -> IO (NET.System.TimeSpan.TimeSpan a0)
negate obj = NET.invoke "Negate"  ()  obj

parse :: String -> IO (NET.System.TimeSpan.TimeSpan a1)
parse arg0 = NET.invokeStatic "System.TimeSpan" "Parse"  (arg0)

tryParse :: String -> NET.System.TimeSpan.TimeSpan a1 -> IO (Bool)
tryParse arg0 arg1 = NET.invokeStatic "System.TimeSpan" "TryParse"  (arg0, arg1)

fromSeconds :: Double -> IO (NET.System.TimeSpan.TimeSpan a1)
fromSeconds arg0 = NET.invokeStatic "System.TimeSpan" "FromSeconds"  (arg0)

subtract :: NET.System.TimeSpan.TimeSpan a0 -> TimeSpan obj -> IO (NET.System.TimeSpan.TimeSpan a1)
subtract arg0 obj = NET.invoke "Subtract"  (arg0) obj

fromTicks :: Data.Int.Int64 -> IO (NET.System.TimeSpan.TimeSpan a1)
fromTicks arg0 = NET.invokeStatic "System.TimeSpan" "FromTicks"  (arg0)

toString :: TimeSpan obj -> IO (String)
toString obj = NET.invoke "ToString"  ()  obj

op_UnaryNegation :: NET.System.TimeSpan.TimeSpan a0 -> IO (NET.System.TimeSpan.TimeSpan a1)
op_UnaryNegation arg0 = NET.invokeStatic "System.TimeSpan" "op_UnaryNegation"  (arg0)

op_Subtraction :: NET.System.TimeSpan.TimeSpan a0 -> NET.System.TimeSpan.TimeSpan a1 -> IO (NET.System.TimeSpan.TimeSpan a2)
op_Subtraction arg0 arg1 = NET.invokeStatic "System.TimeSpan" "op_Subtraction"  (arg0, arg1)

op_UnaryPlus :: NET.System.TimeSpan.TimeSpan a0 -> IO (NET.System.TimeSpan.TimeSpan a1)
op_UnaryPlus arg0 = NET.invokeStatic "System.TimeSpan" "op_UnaryPlus"  (arg0)

op_Addition :: NET.System.TimeSpan.TimeSpan a0 -> NET.System.TimeSpan.TimeSpan a1 -> IO (NET.System.TimeSpan.TimeSpan a2)
op_Addition arg0 arg1 = NET.invokeStatic "System.TimeSpan" "op_Addition"  (arg0, arg1)

op_Equality :: NET.System.TimeSpan.TimeSpan a0 -> NET.System.TimeSpan.TimeSpan a1 -> IO (Bool)
op_Equality arg0 arg1 = NET.invokeStatic "System.TimeSpan" "op_Equality"  (arg0, arg1)

op_Inequality :: NET.System.TimeSpan.TimeSpan a0 -> NET.System.TimeSpan.TimeSpan a1 -> IO (Bool)
op_Inequality arg0 arg1 = NET.invokeStatic "System.TimeSpan" "op_Inequality"  (arg0, arg1)

op_LessThan :: NET.System.TimeSpan.TimeSpan a0 -> NET.System.TimeSpan.TimeSpan a1 -> IO (Bool)
op_LessThan arg0 arg1 = NET.invokeStatic "System.TimeSpan" "op_LessThan"  (arg0, arg1)

op_LessThanOrEqual :: NET.System.TimeSpan.TimeSpan a0 -> NET.System.TimeSpan.TimeSpan a1 -> IO (Bool)
op_LessThanOrEqual arg0 arg1 = NET.invokeStatic "System.TimeSpan" "op_LessThanOrEqual"  (arg0, arg1)

op_GreaterThan :: NET.System.TimeSpan.TimeSpan a0 -> NET.System.TimeSpan.TimeSpan a1 -> IO (Bool)
op_GreaterThan arg0 arg1 = NET.invokeStatic "System.TimeSpan" "op_GreaterThan"  (arg0, arg1)

op_GreaterThanOrEqual :: NET.System.TimeSpan.TimeSpan a0 -> NET.System.TimeSpan.TimeSpan a1 -> IO (Bool)
op_GreaterThanOrEqual arg0 arg1 = NET.invokeStatic "System.TimeSpan" "op_GreaterThanOrEqual"  (arg0, arg1)

get_Zero :: IO (NET.System.TimeSpan.TimeSpan a0)
get_Zero = NET.getFieldStatic "System.TimeSpan" "Zero" ()
get_MaxValue :: IO (NET.System.TimeSpan.TimeSpan a0)
get_MaxValue = NET.getFieldStatic "System.TimeSpan" "MaxValue" ()
get_MinValue :: IO (NET.System.TimeSpan.TimeSpan a0)
get_MinValue = NET.getFieldStatic "System.TimeSpan" "MinValue" ()
get_TicksPerMillisecond :: IO (Data.Int.Int64)
get_TicksPerMillisecond = NET.getFieldStatic "System.TimeSpan" "TicksPerMillisecond" ()
set_TicksPerMillisecond :: Data.Int.Int64 -> IO ()
set_TicksPerMillisecond = NET.setFieldStatic "System.TimeSpan" "TicksPerMillisecond"
get_TicksPerSecond :: IO (Data.Int.Int64)
get_TicksPerSecond = NET.getFieldStatic "System.TimeSpan" "TicksPerSecond" ()
set_TicksPerSecond :: Data.Int.Int64 -> IO ()
set_TicksPerSecond = NET.setFieldStatic "System.TimeSpan" "TicksPerSecond"
get_TicksPerMinute :: IO (Data.Int.Int64)
get_TicksPerMinute = NET.getFieldStatic "System.TimeSpan" "TicksPerMinute" ()
set_TicksPerMinute :: Data.Int.Int64 -> IO ()
set_TicksPerMinute = NET.setFieldStatic "System.TimeSpan" "TicksPerMinute"
get_TicksPerHour :: IO (Data.Int.Int64)
get_TicksPerHour = NET.getFieldStatic "System.TimeSpan" "TicksPerHour" ()
set_TicksPerHour :: Data.Int.Int64 -> IO ()
set_TicksPerHour = NET.setFieldStatic "System.TimeSpan" "TicksPerHour"
get_TicksPerDay :: IO (Data.Int.Int64)
get_TicksPerDay = NET.getFieldStatic "System.TimeSpan" "TicksPerDay" ()
set_TicksPerDay :: Data.Int.Int64 -> IO ()
set_TicksPerDay = NET.setFieldStatic "System.TimeSpan" "TicksPerDay"

